// swig template file 
// Daniel Lemire, March 2004 (Updated July 9th 2004)

// as far as I can tell, the next 3 lines
// define the content of the Python module (presumably, you
// do the same for other languages...?)


//#include "holapcube.h"

%module holap
%{        
#include "fileutil.h"
#include "agmap.h"
#include "multidimensionalarray.h"
#include "bigarray.h"
#include "internalbigarray.h"
#include "btreecube.h"
#include "cdbcube.h"

%}







//I've removed  #include "bighashtable.h"
// now, that's not enough, because this will just generate an
// include, but will not get swig to parse the content
%include "fileutil.h"

#if defined(SWIGJAVA)
%include "arrays_java.i"
JAVA_ARRAYSOFCLASSES(InvertedAgMap)
JAVA_ARRAYSOFCLASSES(MultidimensionalArray<int>)
JAVA_ARRAYSOFCLASSES(MultidimensionalArray<float>)
JAVA_ARRAYSOFCLASSES(MultidimensionalArray<double>)
//%apply multidimensionalarrayi[] {MultidimensionalArray<int>**};




//JAVA_ARRAYSOFCLASSES(MultidimensionalArray<double>*)
//JAVA_ARRAYSOFCLASSES(MultidimensionalIterator<int>*)
//JAVA_ARRAYSOFCLASSES(MultidimensionalIterator<float>*)
//JAVA_ARRAYSOFCLASSES(MultidimensionalIterator<double>*)

#endif

%include "agmap.h"
//we are using STL, we need to tell SWIG about it
%include "std_string.i"
//%include stl.i
%include "std_vector.i"
%include "std_map.i"
%include "exception.i"

namespace std {
  %template(UIntVector) vector<uint>;
  %template(UInt64Vector) vector<uint64>;
  %template(IntVector) vector<int>;
  %template(Int64Vector) vector<long long>;
    

}




%include "multidimensionalarray.h"
%include "bigarray.h"
%include "btreecube.h"
%include "cdbcube.h"
%include "holapcube.h"
%include "internalbigarray.h"


#if defined(SWIGJAVA)
%exception BTreeCube<int>::dynamic_cast(MultidimensionalArray<int> *c) {
    try {
        $action
    } catch(std::bad_cast& e) {
        jclass excep = jenv->FindClass("java/lang/ClassCastException");
        if (excep) jenv->ThrowNew(excep, "dynamic_cast exception");
        return $null;
    }
}

%typemap(throws, throws="java.lang.ClassCastException") std::bad_cast {
  jclass excep = jenv->FindClass("java/lang/ClassCastException");
  if (excep)
    jenv->ThrowNew(excep, $1.what());//.c_str()
  return $null;
}

%typemap(throws, throws="java.io.IOException") std::ifstream::failure {
  jclass excep = jenv->FindClass("java/io/IOException");
  if (excep)
    jenv->ThrowNew(excep, $1.what());//.c_str()
  return $null;
}

%typemap(throws, throws="java.util.NoSuchElementException") std::out_of_range {
  jclass excep = jenv->FindClass("java/util/NoSuchElementException");
  if (excep)
    jenv->ThrowNew(excep, $1.what());//.c_str()
  return $null;
}
%typemap(throws, throws="java.lang.AssertionError") std::invalid_argument {
  jclass excep = jenv->FindClass("java/lang/AssertionError");
  if (excep)
    jenv->ThrowNew(excep, $1.what());//.c_str()
  return $null;
}

%typemap(throws, throws="java.lang.OutOfMemoryError") std::bad_alloc {
  jclass excep = jenv->FindClass("java/lang/OutOfMemoryError");
  if (excep)
    jenv->ThrowNew(excep, $1.what());//.c_str()
  return $null;
}

//
//
//
//
//
%define TEMPLATE_DYNCAST(CT,DT)
%extend CT<DT> {
    static CT<DT> *dynamic_cast(MultidimensionalArray<DT> *c) throw(std::bad_cast){
        CT<DT> *ca = dynamic_cast<CT<DT> *>(c);
        if (ca == NULL) throw std::bad_cast();
        return new CT<DT>(*ca);
    }
};
%enddef

TEMPLATE_DYNCAST(CDBCube,int)
TEMPLATE_DYNCAST(CDBCube,float)
TEMPLATE_DYNCAST(CDBCube,double)
TEMPLATE_DYNCAST(InternalBigArray,int)
TEMPLATE_DYNCAST(InternalBigArray,float)
TEMPLATE_DYNCAST(InternalBigArray,double)
TEMPLATE_DYNCAST(BigArray,int)
TEMPLATE_DYNCAST(BigArray,float)
TEMPLATE_DYNCAST(BigArray,double)
TEMPLATE_DYNCAST(BTreeCube,int)
TEMPLATE_DYNCAST(BTreeCube,float)
TEMPLATE_DYNCAST(BTreeCube,double)


// pointer stuff should be here
// this tells Java or Python they are responsible for deleting
// the objects coming out of these methods (they are pointers)

%define TEMPLATE_WRAP_NEWOBJECT(T) 
%newobject MultidimensionalArray<T>::iterator;
%newobject MultidimensionalArray<T>::partial_rollup;
%newobject MultidimensionalArray<T>::full_rollup;
%newobject MultidimensionalArray<T>::map_pointwise;
%newobject MultidimensionalArray<T>::slice;
%newobject MultidimensionalArray<T>::sliceIterator;
%newobject MultidimensionalArray<T>::topNIterator;
%newobject MultidimensionalArray<T>::iceberg;
%newobject MultidimensionalArray<T>::map_1dvectors;
%newobject MultidimensionalArray<T>::collapse;
%newobject MultidimensionalArray<T>::glue;
%newobject MultidimensionalArray<T>::prepend_zero_coordinate;
%enddef

TEMPLATE_WRAP_NEWOBJECT(int)
TEMPLATE_WRAP_NEWOBJECT(float)
TEMPLATE_WRAP_NEWOBJECT(double)

#endif



// we need to define instances
%template(multidimensionalarrayi) MultidimensionalArray<int>;
%template(multidimensionalarrayf) MultidimensionalArray<float>;
%template(multidimensionalarrayd) MultidimensionalArray<double>;
%template(iteratori) MultidimensionalIterator<int>;
%template(iteratorf) MultidimensionalIterator<float>;
%template(iteratord) MultidimensionalIterator<double>;

//%template(holapcubei) HolapCube<int>;
//%template(holapcubef) HolapCube<float>;
%template(bigarrayi) BigArray<int>;
%template(bigarrayf) BigArray<float>;
%template(bigarrayd) BigArray<double>;
%template(internalbigarrayi) InternalBigArray<int>;
%template(internalbigarrayf) InternalBigArray<float>;
%template(internalbigarrayd) InternalBigArray<double>;
%template(btreecubei) BTreeCube<int>;
%template(btreecubef) BTreeCube<float>;
%template(btreecubed) BTreeCube<double>;
%template(cdbcubei) CDBCube<int>;
%template(cdbcubef) CDBCube<float>;
%template(cdbcubed) CDBCube<double>;

%template(icebergiteratori) IcebergMultidimensionalIterator<int>;
%template(icebergiteratorf) IcebergMultidimensionalIterator<float>;
%template(icebergiteratord) IcebergMultidimensionalIterator<double>;

%template(buffered_iteratori) BufferedIterator<int>;
%template(buffered_iteratorf) BufferedIterator<float>;
%template(buffered_iteratord) BufferedIterator<double>;

%template(delete_dimension_iteratori) DeleteDimensionIterator<int>;
%template(delete_dimension_iteratorf) DeleteDimensionIterator<float>;
%template(delete_dimension_iteratord) DeleteDimensionIterator<double>;


%template(prepend_dimension_iteratori) PrependDimensionIterator<int>;
%template(prepend_dimension_iteratorf) PrependDimensionIterator<float>;
%template(prepend_dimension_iteratord) PrependDimensionIterator<double>;

%template(glue_iteratori) GlueIterator<int>;
%template(glue_iteratorf) GlueIterator<float>;
%template(glue_iteratord) GlueIterator<double>;

%template(intCubeSet) CubeSet<int>;
%template(floatCubeSet) CubeSet<float>;
%template(doubleCubeSet) CubeSet<double>;


%template(intIteratorSet) IteratorSet<int>;
%template(floatIteratorSet) IteratorSet<float>;
%template(doubleIteratorSet) IteratorSet<double>;

//%template(btreecubeiteratori) BTreeCubeIterator<int>;
//%template(btreecubeiteratorf) BTreeCubeIterator<float>;
//%template(bigarrayiteratori) BigArrayIterator<int>;
//%template(bigarrayiteratord) BigArrayIterator<float>;
//%template(cubeiteratori) CubeIterator<int>;
//%template(cubeiteratorf) CubeIterator<float>;


