import Swig.*;

public class test {
  static {
    try {
      System.loadLibrary("holap");
     } catch(java.lang.UnsatisfiedLinkError e) {
     e.printStackTrace();
     System.err.println("Java can't find holap library");
     System.err.println("Make sure libholap.so is in the following path:");
     System.err.println(System.getProperty("java.library.path"));
     System.err.println(" You can add to this list by setting LD_LIBRARY_PATH");

     System.err.println(" For example, try entering 'LD_LIBRARY_PATH=. java test'");
     }
  }
public static void main(String[] arg) throws java.lang.Exception {
 System.out.println("Testing the wrapping of a C++ bigarray in Java");
 String myfile = "somefilename.bin";
 {
 btreecubei bti=new btreecubei(3,myfile);//3 is number of dimensions
 iteratori i = bti.iterator(new int[]{0,0,0},new int[]{2,2,2});
 }
 {
 btreecubef btf=new btreecubef(3,myfile);//3 is number of dimensions
 iteratorf i = btf.iterator(new int[]{0,0,0},new int[]{2,2,2});
 }
 {bigarrayi c=new bigarrayi(new int[]{4,4,4},3,myfile);
 c.fillWithZeroes();// not needed but a good test
 System.out.println("File somefilename.bin should have "+c.getVolume().intValue()*4+" bytes");
 System.out.println(" putting 1 in a cell");
 c.put(new int[]{0,0,1},1);
 System.out.println( "I expect to read 1");
 int result =  c.get(new int[]{0,0,1});
 System.out.println(result);
 if( result != 1) {
   System.err.println("*** You have a problem friend. *** ");
 }
 System.out.println("using iterators");

 iteratori ci = c.iterator(new int[]{0,0,0},new int[]{2,2,2});
 while(ci.next())
   System.out.println(toString(ci.key())+ " "+ ci.value());
 c.close();
 }
 {
 bigarrayf cf=new bigarrayf(new int[]{4,4,4},3,myfile);
 cf.fillWithZeroes();// not needed but a good test
 System.out.println("File somefilename.bin should have "+cf.getVolume().intValue()*4+" bytes");
 System.out.println(" putting 1 in a cell");
 cf.put(new int[]{0,0,1},1.0f);
 System.out.println( "I expect to read 1");
 float result =  cf.get(new int[]{0,0,1});
 System.out.println(result);
 if( result != 1.0f) {
   System.err.println("*** You have a problem friend. *** ");
 }
 cf.close();
 }
 System.out.println("Done testing bigarray. It should work.");
 System.out.println("You'll find the result in the flat binary file "+ myfile);
 System.out.println("This is a good idea for small cubes (all dense).");
 System.out.println("");
}


public static String toString(IntVector b) {
  String ans = "(";
  for (int k = 0; k < b.size() - 1; ++k) {
	ans += b.get(k) + ", ";
	}
	ans += b.get((int)b.size()-1);
	ans += ")";
	return ans;
}
}


